;rotary about arbitrary vector implemented by Maciej Guba
;  ebx - normalized vector 3 dwords, each dword coefficient
;  esi - cosinus and sinus of angle
;  edi - desieres matrix
make_arbitrary_mx:
 .nx	  equ dword[ebx]
 .ny	  equ dword[ebx+4]
 .nz	  equ dword[ebx+8]
 .sinus   equ dword[esi]
 .cosinus equ dword[esi+4]
 fninit
 fld	dword[ebx]
 fmul	st,st0
 fld	st
 fchs
 fld1
 faddp
 fmul	.cosinus ; dword[esi]
 faddp
 fstp	dword[edi]

 fld	.nx
 fmul	.ny
 fld	.cosinus
 fchs
 fld1
 faddp
 fmulp
 fld	.nz ;dword[ebx+8]
 fmul	.sinus	;dword[esi]
; fchs
 faddp
 fstp	dword[edi+4]

 fld	.nx
 fmul	.nz
 fld1
 fld	.cosinus
 fchs
 faddp
 fmulp
 fld	.ny
 fmul	.sinus
 fchs
 faddp
 fstp	dword[edi+8]

 fld	.nx
 fmul	.ny
 fld1
 fld	.cosinus
 fchs
 faddp
 fmulp
 fld	.sinus
 fmul	.nz
 fchs
 faddp
 fstp	dword[edi+12]

 fld	.ny
 fmul	st,st0
 fld	st
 fchs
 fld1
 faddp
 fmul	.cosinus
 faddp
 fstp	dword[edi+16]

 fld	.ny
 fmul	.nz
 fld1
 fld	.cosinus
 fchs
 faddp
 fmulp
 fld	.sinus
 fmul	.nx
; fchs
 faddp
 fstp	dword[edi+20]

 fld	.nx
 fmul	.nz
 fld1
 fld	.cosinus
 fchs
 faddp
 fmulp
 fld	.ny
 fmul	.sinus
; fchs
 faddp
 fstp	dword[edi+24]

 fld	.ny
 fmul	.nz
 fld1
 fld	.cosinus
 fchs
 faddp
 fmulp
 fld	.nx
 fmul	.sinus
 fchs
 faddp
 fstp	dword[edi+28]

 fld	.nz
 fmul	st,st0
 fld	st
 fchs
 fld1
 faddp
 fmul  .cosinus
 faddp
 fstp  dword[edi+32]
ret




save_object:	   ; make_object - rotate around axis, do points list
		   ; do triangles list and save to 3ds file
   pushad
  .counter equ word [ebp-4]
  .rot_points_ptr equ  dword [ebp-8]
   mov	ebp,esp
   sub	esp,32

   mov	esi,x1_axis
   mov	edi,x2_axis
   mov	ebx,x_axis_v
   call make_vector_r
   mov	edi,x_axis_v
   call normalize_vector
   xor	eax,eax
   fninit
   mov	.rot_points_ptr,points_r      ; points describing rotated solid
 .loop1:

   push  eax
   mov	 ebx,x_axis_v
   mov	 edi,matrix
   mov	 .counter,ax	    ; degrees counter
   fld	 [one_deg]
   fimul .counter
   fsincos
   fstp  [sinus]
   fstp  [cosinus]
   lea	 esi,[sinus]
   call  make_arbitrary_mx

   mov	 ebx,matrix
   movzx ecx,[maxcountervar]

   mov	esi,points
   mov	edi,.rot_points_ptr
   pushad
   call  mul_matrix
   popad
   pop	 eax

   add	 .rot_points_ptr,STEPS*12
   inc	 eax
   cmp	 eax, ROTARY_STEPS+2
   jne	 .loop1

   ; do triangles list



   mov	 esi,triangles

   mov	  edx,STEPS-2
   mov	  [triangles_count],0	  ; do triangles list
   xor	  ebx,ebx
  .oop2:
   mov	  ecx,STEPS-1
  @@:
   mov	  ax,bx
   mov	  [esi],ax
   inc	  ax
   mov	  [esi+8],ax
   mov	  [esi+4],ax
   add	  ax, STEPS-1
   mov	  [esi+2],ax
   mov	  [esi+6],ax
   inc	  ax
   mov	  [esi+10],ax
   add	  esi,12
   inc	  bx
   add	  [triangles_count],2
   loop   @b
   add	  bx,1

   dec	  dx
   cmp	  dx,0
   jnz	  .oop2


   mov	  ecx,(STEPS-1) * (STEPS-1) - 1
   xor	  ebx,ebx
 @@:
   mov	  eax,ebx
   mov	  [esi],ax
   inc	  ax
   mov	  [esi+2],ax
   mov	  [esi+4],cx
   mov	  [esi+6],cx
   inc	  cx
   mov	  [esi+8],ax
   mov	  [esi+10],cx
   add	  esi,12
   add	  [triangles_count],2
   inc	  ebx
   cmp	  ebx,STEPS-1
   jne	  @b


   mov	 [esi],dword -1



    pushad
    mov edi,file_buffer
    mov [edi],word 4d4dh
    add edi,6
    mov [edi],word 3d3dh
    add edi,6
    mov [edi],word 4000h
    add edi,6
    mov [edi],byte 0
    inc edi
    mov [edi],word 4100h     ;    [global_points_counter]
    add  edi,6
    mov [edi],word 4110h
    mov ecx,[global_points_counter] ;MAX_COUNTER*MAX_COUNTER  ;all points count

    mov eax,ROTARY_STEPS-1
    mul ecx
    mov ecx,eax

    mov edx,ecx
    mov [edi+6],cx
    add edi,8
    mov esi,points_r
    xor ebx,ebx
    lea ecx,[ecx*3]
@@:
    rep movsd
    mov  [edi],word 4120h
    mov  ecx,[triangles_count]
    mov  [edi+6],cx
    add  edi,8
    mov  esi,triangles
    cld
 @@:
    movsd
    movsw
    add  edi,2
    loop @b

    sub  edi,file_buffer
    mov  [file_buffer+2],edi
    mov  [file_size],edi

    invoke  CreateFile,file_name, GENERIC_WRITE, 0, 0,CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, 0
    mov  [file_handle],eax
    invoke  WriteFile,eax,file_buffer,[file_size], byteswritten, 0
    invoke  CloseHandle,[file_handle]

    popad
    mov   esp,ebp
    popad
ret






